package com.enteprise.util;

import com.enteprise.common.constant.HttpStatus;
import com.enteprise.common.core.page.TableDataInfo;
import com.enteprise.enterprise.dto.EnterpriseDto;
import com.github.pagehelper.PageInfo;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class CommonUtil {
    /**
     * 获取两个值之间的所有整数
     * @param start
     * @param end
     * @return
     */
    public static List<Integer> getRange(int start, int end) {
        // 创建一个列表以存储结果
        List<Integer> list = new ArrayList<>();

        // 确定区间的起始和结束值
        int min = Math.min(start, end);
        int max = Math.max(start, end);

        // 使用循环将范围内的所有值添加到列表中
        for (int i = min; i <= max; i++) {
            list.add(i);
        }

        return list;
    }

    public static List<EnterpriseDto> sortByNumberInName(List<EnterpriseDto> list) {
        List<EnterpriseDto> newList = new ArrayList<>(list);
        newList.sort(new Comparator<EnterpriseDto>() {
            @Override
            public int compare(EnterpriseDto a1, EnterpriseDto a2) {
                int num1 = extractNumber(a1.getEnterpriseName());
                int num2 = extractNumber(a2.getEnterpriseName());
                return Integer.compare(num1, num2);
            }
        });
        return newList;
    }

    // 从名称中提取数字的方法
    private static int extractNumber(String name) {
        // 使用正则表达式提取出字符串中的数字部分
        String numberPart = name.replaceAll("\\D+", ""); // 去掉非数字字符
        return Integer.parseInt(numberPart.isEmpty() ? "0" : numberPart); // 转换为整数，默认返回 0
    }

        public static TableDataInfo startPageL(List list, Integer pageNum, Integer pageSize) {
            if (list == null) {
                return null;
            }
            if (list.size() == 0) {
                return null;
            }
            Integer count = list.size(); // 记录总数
            Integer pageCount = 0; // 页数
            if (count % pageSize == 0) {
                pageCount = count / pageSize;
            } else {
                pageCount = count / pageSize + 1;
            }
            int fromIndex = 0; // 开始索引
            int toIndex = 0; // 结束索引
            if (pageNum != pageCount) {
                fromIndex = (pageNum - 1) * pageSize;
                toIndex = fromIndex + pageSize;
            } else {
                fromIndex = (pageNum - 1) * pageSize;
                toIndex = count;
            }
            List pageList = list.subList(fromIndex, toIndex);
            TableDataInfo rspData = new TableDataInfo();
            rspData.setCode(HttpStatus.SUCCESS);
            rspData.setMsg("查询成功");
            rspData.setRows(pageList);
            rspData.setTotal(new PageInfo(list).getTotal());
            return rspData;
        }

    }


